# Edited by rpmlb
%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global gem_name activesupport

Summary: A support libraries and Ruby core extensions extracted from the Rails framework
Name: %{?scl_prefix}rubygem-%{gem_name}
Epoch: 1
Version: 5.0.1
Release: 3%{?dist}
Group: Development/Languages
License: MIT
URL: http://rubyonrails.org

Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem

# The activesupport gem doesn't ship with the test suite like the other
# Rails rpms, you may check it out like so
# git clone http://github.com/rails/rails.git
# cd rails/activesupport/
# git checkout v5.0.1 && tar czvf activesupport-5.0.1-tests.tgz test/
Source1: %{gem_name}-%{version}-tests.tgz

# Make the test which needs online access optional.
# https://github.com/rails/rails/pull/25678
Patch1: rubygem-activesupport-5.0.0-DRY-Downloader.patch
Patch2: rubygem-activesupport-5.0.0-Skip-the-test-if-test-data-download-fails.patch

# Fixnum and Bignum are deprecated in Ruby trunk
# https://github.com/rails/rails/pull/26732
Patch3: rubygem-activesupport-5.0.1-Fixnum-and-Bignum-are-deprecated-in-Ruby-trunk.patch
Patch4: rubygem-activesupport-5.0.1-Fixnum-and-Bignum-are-deprecated-in-Ruby-trunk-tests.patch

# Fix parsing decimal on Ruby 2.4.
# https://github.com/rails/rails/commit/b3d8117
Patch5: rubygem-activesupport-5.0.1-parsing-decimal.patch

# Fix duplicable on Ruby 2.4.
# https://github.com/rails/rails/commit/89fcd13
Patch6: rubygem-activesupport-5.0.1-duplicable.patch
Patch7: rubygem-activesupport-5.0.1-duplicable-tests.patch

# Fix duplicable symbol on Ruby 2.4.
# https://github.com/rails/rails/commit/2badd55
Patch8: rubygem-activesupport-5.0.1-duplicable-symbol.patch
Patch9: rubygem-activesupport-5.0.1-duplicable-symbol-tests.patch

# Fix iso8601 output on Ruby 2.4.
# https://github.com/rails/rails/commit/c784102
Patch10: rubygem-activesupport-5.0.1-iso8601_output.patch

# Fix Fixnum deprecated warning in Ruby 2.4+
# https://github.com/rails/rails/commit/598f10c
Patch11: rubygem-activesupport-5.0.1-Fix-Fixnum-duration-test.patch

# Remove Bignum deprecated warning in Ruby 2.4+
# https://github.com/rails/rails/commit/8683ac5
Patch12: rubygem-activesupport-5.0.1-remove-warning-from-Bignum.patch

# ruby package has just soft dependency on rubygem(bigdecimal), while
# ActiveSupport always requires it.
Requires: %{?scl_prefix_ruby}rubygem(bigdecimal)

# Let's keep Requires and BuildRequires sorted alphabeticaly
Requires: %{?scl_prefix_ruby}ruby(release)
Requires: %{?scl_prefix_ruby}ruby(rubygems)
Requires: %{?scl_prefix}rubygem(i18n) >= 0.7
Requires: %{?scl_prefix}rubygem(i18n) < 1
Requires: %{?scl_prefix_ruby}rubygem(json)
Requires: %{?scl_prefix_ruby}rubygem(minitest) >= 5.1
Requires: %{?scl_prefix_ruby}rubygem(minitest) < 6
Requires: %{?scl_prefix}rubygem(tzinfo) >= 1.1
Requires: %{?scl_prefix}rubygem(tzinfo) < 2
Requires: %{?scl_prefix}rubygem(concurrent-ruby)
BuildRequires: %{?scl_prefix_ruby}ruby(release)
BuildRequires: %{?scl_prefix_ruby}ruby(rubygems)
BuildRequires: %{?scl_prefix_ruby}ruby
BuildRequires: %{?scl_prefix_ruby}rubygems-devel
BuildRequires: %{?scl_prefix_ruby}rubygem(bigdecimal)
BuildRequires: %{?scl_prefix}rubygem(builder)
BuildRequires: %{?scl_prefix}rubygem(concurrent-ruby)
BuildRequires: %{?scl_prefix}rubygem(dalli)
BuildRequires: %{?scl_prefix}rubygem(i18n) >= 0.6.9
BuildRequires: %{?scl_prefix}rubygem(i18n) < 1.0
BuildRequires: %{?scl_prefix_ruby}rubygem(minitest) >= 5.0.0
BuildRequires: %{?scl_prefix}rubygem(rack)
BuildRequires: %{?scl_prefix}rubygem(tzinfo) >= 1.1
BuildRequires: %{?scl_prefix}rubygem(tzinfo) < 2.0
BuildArch: noarch
Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}

# Explicitly require runtime subpackage, as long as older scl-utils do not generate it
%{?scl:Requires: %{?scl_prefix}runtime}


%description
A toolkit of support libraries and Ruby core extensions extracted from the
Rails framework. Rich support for multibyte strings, internationalization,
time zones, and testing.

%package doc
Summary: Documentation for %{pkg_name}
Group: Documentation
Requires: %{?scl_prefix}%{pkg_name} = %{epoch}:%{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{pkg_name}.

%prep
%setup -n %{pkg_name}-%{version} -q -c -T
%{?scl:scl enable %{scl} - << \EOF}
set -e
%gem_install -n %{SOURCE0}
pushd .%{gem_instdir}
%patch3 -p2
%patch5 -p2
%patch6 -p2
%patch8 -p2
popd
%{?scl:EOF}

%build

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}
# Move the tests into place
tar xzvf %{SOURCE1}

cat %{PATCH1} | patch -p2
cat %{PATCH2} | patch -p2
patch -p2 < %{PATCH4}
cat %{PATCH7} | patch -p2
cat %{PATCH9} | patch -p2
cat %{PATCH10} | patch -p2
cat %{PATCH11} | patch -p2
cat %{PATCH12} | patch -p2

# These tests are really unstable, but they seems to be passing upstream :/
for f in test/evented_file_update_checker_test.rb test/file_update_checker_test.rb; do
  mv $f{,.disable}
done

# These seems to be unstable as well ...
# https://github.com/rails/rails/issues/25683
sed -i '/^class MemoryStoreTest/,/^end/ s/^/#/' test/caching_test.rb
# https://github.com/rails/rails/issues/25682
sed -i '/def test_iso8601_output_and_reparsing$/,/^  end$/ s/^/#/' test/core_ext/duration_test.rb

%{?scl:scl enable %{scl} - << \EOF}
ruby -Ilib:test -e 'Dir.glob "./test/**/*_test.rb", &method(:require)'
%{?scl:EOF}
popd

%files
# There is no %%license macro on RHEL6.
# https://bugzilla.redhat.com/show_bug.cgi?id=1386246
%{!?_licensedir:%global license %%doc}

%dir %{gem_instdir}
%license %{gem_instdir}/MIT-LICENSE
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/README.rdoc

%changelog
* Tue Feb 14 2017 Jun Aruga <jaruga@redhat.com> - 1:5.0.1-3
- Fix Fixnum/Bignum deprecated warning for Ruby 2.4.0.

* Thu Jan 12 2017 Jun Aruga <jaruga@redhat.com> - 1:5.0.1-2
- Update Requires rubygem-json for SCL rh-ruby24.

* Thu Jan 12 2017 Jun Aruga <jaruga@redhat.com> - 1:5.0.1-1
- Update to Active Support 5.0.1.
- Fix warnings: Fixnum and Bignum are deprecated in Ruby trunk
- Fix Ruby 2.4.0 compatibility.

* Mon Apr 04 2016 Pavel Valena <pvalena@redhat.com> - 1:4.2.6-1
- Update to 4.2.6

* Mon Feb 29 2016 Pavel Valena <pvalena@redhat.com> - 1:4.2.5.1-4
- Remove unused patch

* Wed Feb 17 2016 Pavel Valena <pvalena@redhat.com> - 1:4.2.5.1-3
- Update to 4.2.5.1

* Tue Feb 16 2016 Pavel Valena <pvalena@redhat.com> - 1:4.1.5-3
- Fix offset in patch for CVE-2016-0753

* Wed Feb 10 2016 Pavel Valena <pvalena@redhat.com> - 1:4.1.5-2
- Fix possible input validation circumvention - rhbz#1301973
  - Resolves: CVE-2016-0753
- Fix Timing attack vulnerability in basic authentication - rhbz#1301933
  - Resolves: CVE-2015-7576

* Mon Jan 19 2015 Josef Stribny <jstribny@redhat.com> - 1:4.1.5-1
- Update to 4.1.5

* Fri Jan 31 2014 Vít Ondruch <vondruch@redhat.com> - 1:4.0.2-3
- Remove unneeded patch.

* Thu Jan 23 2014 Vít Ondruch <vondruch@redhat.com> - 1:4.0.2-2
- Fix minitest dependency.

* Wed Dec 04 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.2-1
- Update to ActionSupport 4.0.2
  - Resolves: rhbz#1037985

* Thu Nov 21 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.1-1
- Update to ActiveSupport 4.0.1

* Thu Oct 17 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.0-2
- Add missing minitest runtime dep

* Thu Oct 03 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.0-1
- Update to ActiveSupport 4.0.0.

* Fri Jun 07 2013 Josef Stribny <jstribny@redhat.com> - 1:3.2.13-1
- Rebuild for https://fedoraproject.org/wiki/Features/Ruby_2.0.0
- Update to ActiveSupport 3.2.13.

* Wed Feb 27 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.2.8-4
- Rebuild to fix documentation vulnerability due to CVE-2013-0256.

* Thu Jan 10 2013 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.2.8-3
- Fix for CVE-2013-0156.

* Thu Oct 04 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.2.8-2
- Fix name given to %%scl_package.

* Tue Sep 18 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.2.8-1
- Update to ActiveSupport 3.2.8.

* Tue Jul 31 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.2.6-3
- Remove the cached gem.

* Wed Jul 25 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.2.6-2
- Recreated for SCL from Fedora again.

* Wed Jul 18 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.2.6-1
- Update to ActiveSupport 3.2.6.
- Removed unneeded BuildRoot tag.
- Tests no longer fail with newer versions of Mocha, remove workaround.

* Fri Jun 15 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.0.15-1
- Update to ActiveSupport 3.0.15.

* Fri Jun 01 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.0.13-1
- Update to ActiveSupport 3.0.13.

* Wed Apr 18 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.0.11-5
- Add the bigdecimal dependency to gemspec.

* Fri Mar 16 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.0.11-4
- The CVE patch name now contains the CVE id.

* Mon Mar 05 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.0.11-3
- Patch for CVE-2012-1098

* Tue Jan 24 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.0.11-1
- Rebuilt for Ruby 1.9.3.
- Update to ActiveSupport 3.0.11.

* Mon Aug 22 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.10-1
- Update to ActiveSupport 3.0.10

* Fri Jul 01 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.9-1
- Update to ActiveSupport 3.0.9
- Changed %%define into %%global
- Removed unnecessary %%clean section

* Thu Jun 16 2011 Mo Morsi <mmorsi@redhat.com> - 1:3.0.5-3
- Reverting accidental change adding a few gem flags

* Thu Jun 16 2011 Mo Morsi <mmorsi@redhat.com> - 1:3.0.5-2
- Include fix for CVE-2011-2197

* Thu Mar 24 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.5-1
- Update to ActiveSupport 3.0.5
- Remove Rake dependnecy

* Mon Feb 14 2011 Mohammed Morsi <mmorsi@redhat.com> - 1:3.0.3-4
- fix bad dates in the spec changelog

* Thu Feb 10 2011 Mohammed Morsi <mmorsi@redhat.com> - 1:3.0.3-3
- include i18n runtime dependency

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:3.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 10 2011 Mohammed Morsi <mmorsi@redhat.com> - 1:3.0.3-1
- update to rails 3

* Wed Aug 25 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-2
- bumped version

* Wed Aug 04 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-1
- Update to 2.3.8
- Added check section with rubygem-mocha dependency
- Added upsteam Rakefile and test suite to run tests

* Thu Jan 28 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1:2.3.5-1
- Update to 2.3.5

* Wed Oct  7 2009 David Lutterkort <lutter@redhat.com> - 1:2.3.4-2
- Bump Epoch to ensure upgrade path from F-11

* Mon Sep 7 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.3.4-1
- Update to 2.3.4 (bug 520843, CVE-2009-3009)

* Sun Jul 26 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 2.3.3-1
- New upstream version

* Mon Mar 16 2009 Jeroen van Meeuwen <kanarip@fedoraproject.org> - 2.3.2-1
- New upstream version

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Nov 24 2008 Jeroen van Meeuwen <kanarip@fedoraproject.org> - 2.2.2-1
- New upstream version

* Tue Sep 16 2008 David Lutterkort <dlutter@redhat.com> - 2.1.1-1
- New version (fixes CVE-2008-4094)

* Thu Jul 31 2008 Michael Stahnke <stahnma@fedoraproject.org> - 2.1.0-1
- New Upstream

* Mon Apr 07 2008 David Lutterkort <dlutter@redhat.com> - 2.0.2-1
- New version

* Mon Dec 10 2007 David Lutterkort <dlutter@redhat.com> - 2.0.1-1
- New version

* Wed Nov 28 2007 David Lutterkort <dlutter@redhat.com> - 1.4.4-3
- Fix buildroot

* Tue Nov 14 2007 David Lutterkort <dlutter@redhat.com> - 1.4.4-2
- Install README and CHANGELOG in _docdir

* Tue Oct 30 2007 David Lutterkort <dlutter@redhat.com> - 1.4.4-1
- Initial package
